#include "rpg.h"

byte messageType::txt_alloc(int size)
{
  if (size == 0 || size == -1) return 1;
  txt = (char far *)farmalloc(size + 1);
  if (txt == NULL) return NULL;
  length = size;
  return 1;
}

void messageType::txt_free(void)
{
  if (length != -1)
  {
    farfree(txt);
    length = -1;
  }
}

byte messageType::txt_read(FILE *handle)
{
  int l;
  txt_free();
  fread(&l, 1, sizeof(l), handle);
  if (txt_alloc(l) == NULL) return NULL;
  int x;
  for (x = 0; x < l + 1; x++)
    txt[x] = fgetc(handle);
  return 1;
}

void messageType::txt_write(FILE *handle)
{
  fwrite(&length, 1, sizeof(length), handle);
  int x;
  for (x = 0; x < length + 1; x++)
    fputc(txt[x], handle);
}
