#ifndef __MOUSE_H
#define __MOUSE_H

extern int resetMouse(int *buttons);
extern void showMouse(void);
extern void hideMouse(void);
extern void mouseXYButtons(int *x, int *y, int *buttons);
extern void setMouseXY(int x, int y);
extern void getMouseButtonPressInfo(int button, int *count, int *x, int *y,
                                    int *status);
extern void getMouseButtonReleaseInfo(int button, int *count, int *x, int *y,
                                      int *status);
extern void setMouseMinMax(int minX, int minY, int maxX, int maxY);
extern void setMouseGraphicsCursor(int xHot, int yHot,
                                   unsigned char far *bitmap);
extern void mouseMotionRel(int *x, int *y);
extern void mouseSetSensitivity(int x, int y, int dblSpeed);
extern void setMouseTextCursor(int cursor, int start, int end);
extern void readMouseMotionCounters(int *x, int *y);
extern void setMouseMickeyPixelRatio(int x, int y);

#endif
