#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include <mem.h>
#include <ctype.h>

#include "pcx.h"
#include "graphics.h"
#include "keyboard.h"
#include "types.h"
#include "htimer.h"

#define SHAREDEMB

extern "C"
{
#include "smix.h"
#include "detect.h"
}

#include "defines.h"
#include "rpgtypes.h"
#include "vars.h"

#define mapTable(x, y) map[(y) * MAP_X_SIZE + (x)]
#define bTable(x, y) battleMap[(y) * MAP_X_SIZE + (x)]

extern void errorAbort(char *message);
extern void allocMem(void);
extern void freeMem(void);
extern void loadData(void);
extern void Init(void);
extern void Close(void);

extern void blitCoolString(int x, int y, char *text);
extern void HDelay(long msecs);
extern int  additem(int type, int num);
extern void PlaySound(int num);
extern void intro(void);
extern void mainMenu(void);
extern void talkMessage(char far *message);
extern void subArea(int area, int direction);
extern void newGame(int where);

extern void battle(int type, int backnum);

extern void menu(int where);

extern void blitTile(int x, int y, byte tile);
extern void blitSprite(int x, int y, byte sprite);
extern void loadTiles(char *file, byte far *buffer, byte walkTable[NUM_TILES]);
extern void loadSprites(char *file, byte far *buffer);
extern void loadMap(char *file, byte far *map, byte far *battleMap);
extern void drawMap(int slideX, int slideY);
extern void slideMap(int x, int y);
extern void window(int x, int y, int sx, int sy);

inline int playerType::attack(void)
{ return strength + (weapon == UNEQUIPPED ? 0 :
                     gamedata.weapons[weapon].attack); }

inline int playerType::mpower(void)
{ return wisdom; }

inline int playerType::defense(void)
{
  int d = (strength + speed) / 2 +
          (shield == UNEQUIPPED ? 0 : gamedata.shields[shield].defense) +
          (helmet == UNEQUIPPED ? 0 : gamedata.helmets[helmet].defense) +
          (mail   == UNEQUIPPED ? 0 : gamedata.mails  [mail]  .defense);
  if (d > 99) d = 99;
  return d;
}

inline int playerType::mdef(void)
{ return (strength + wisdom) / 2; }
