// KEYBOARD.H
// Keyboard Library Header

#define byte unsigned char

extern volatile byte rawKey;
extern volatile byte keyTable[128];

extern void initKeyboard(void);
extern void closeKeyboard(void);
extern byte keyPressed(void);
extern void pause(void);

#define UPARROW    72
#define DOWNARROW  80
#define LEFTARROW  75
#define RIGHTARROW 77
#define ENTER      28
#define ESC        1
#define SPACEBAR   57      
